package com.jiuqi.mde;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.jiuqi.mde.MDEDimValueSet;
import com.jiuqi.mde.MDEDimension;
import com.jiuqi.mde.MDEException;
import com.jiuqi.util.RecIndex;

public final class MDEIndex extends RecIndex {
  public void genOrder(MDEDimValueSet dimValues) throws MDEException {
    genOrder(dimValues, false);
  }
  
  public void genOrder(MDEDimValueSet dimValues, boolean clearOrder) throws MDEException {
    int order = dimValues.dimensions().indexOf("顺序号");
    if (order < 0)
      return; 
    if (order != dimValues.dimensions().size() - 1)
      throw new MDEException("顺序号维度必须是维度集合的最后一个"); 
    if (dimValues.getValue(order) != null) {
      int i = -1;
      if (clearOrder)
        i = search(dimValues); 
      if (i < 0)
        return; 
    } 
    dimValues.setValue(order, MDEDimension.MAX_INT_DIM_VALUE);
    int index = search(dimValues);
    if (index >= 0)
      throw new MDEException("顺序号维度已达到最大值"); 
    index = -1 - index;
    if (index > 0 && dimValues.compareNoOrder(getKey(index - 1)) == 0) {
      MDEDimValueSet values = (MDEDimValueSet)getKey(index - 1);
      dimValues.setValue(order, 
          new Integer(((Integer)values.getValue(order))
            .intValue() + 1));
    } else {
      dimValues.setValue(order, new Integer(1));
    } 
  }
  
  public int findNoOrder(MDEDimValueSet dimValues) {
    int index = searchfirst(dimValues);
    if (index < 0) {
      index = -1 - index;
      if (index < size() && 
        dimValues.compareNoOrder(getValue(index)) == 0)
        return index; 
      if (index > 0 && dimValues.compareNoOrder(getValue(index - 1)) == 0)
        return index - 1; 
    } 
    return -1;
  }
  
  public int findFirstNoOrder(MDEDimValueSet dimValues) {
    MDEDimValueSet newValues = dimValues;
    int order = dimValues.dimensions().indexOf("顺序号");
    if (order >= 0) {
      newValues = (MDEDimValueSet)dimValues.clone();
      newValues.setValue(order, null);
    } 
    return findNoOrder(newValues);
  }
}
